import java.util.*;
import java.io.*;
import ListOf;

class ListOfAddr extends ListOf{
	
	public void addToList(Object obj){
		Addr bindAddr=(Addr) obj;
		if (! this.contains(bindAddr.name)) add(bindAddr);
		else System.out.println("Elemento ripetuto!");
	}
	
	public boolean contains(Object obj){
		String bindAddr=(String) obj;
		boolean trovato=false;
		for (int i=0;i<this.size();i++)
			//cerco il nome (passato al metodo) in un istanza di ListOfNames
			if (bindAddr.equals( ((Addr)this.get(i)).name ) ) trovato=true;
		return trovato; 
	}
	
	public int index(Object obj){
		String bindAddr=(String) obj;
		int i=0;
		for (i=0;i<this.size();i++)
			if (((Addr)this.get(i)).name.equals(bindAddr))
				return i;
		return (-1);
	}

	public String removeFromList(Object obj){
		Addr bindAddr=(Addr) obj;
		int i=0;
		if (this.contains(bindAddr.name)) {
			remove(bindAddr);
			return (bindAddr+"  stato rimosso dalla lista");
		}
		else return (bindAddr+" non  presente nella lista");
	}
	
	public void saveToDisk(String path){
		try {
			ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(path));
			out.writeObject(this);
			out.close();
		}
		catch (FileNotFoundException e) {
			System.out.println("Errore in salvataggio");
		}
		catch (IOException e) {
			System.out.println("Errore di I/O");
		}
	}
	
	public void displayList(){
		int i;
		for (i=0;i<this.size();i++) 
			System.out.println(((Addr)this.get(i)).name+" "+((Addr)this.get(i)).Ip+" "+((Addr)this.get(i)).Port);
	}
}