import java.net.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;

public class listenOpponent implements Runnable {
	
	Client app;
	Socket opp;
	ServerSocket gameSk;
	String user= new String();
	String type= new String();
	String white= new String();
	String black= new String();
	String first= new String();
	ObjectOutputStream out; 
	ObjectInputStream in;


	listenOpponent(Client app) {
		this.app=app;
	}
	
	public void run() {
		InputStream input;
		OutputStream output;

		try {
			while (true) {
				opp=app.gameSk.accept();			
				try {
					out =new ObjectOutputStream(opp.getOutputStream());
					in =new ObjectInputStream(opp.getInputStream());
				} catch (IOException w) { 
					System.out.println("Errore di I/O");
				}
				try {
					type=(String) in.readObject();
				}	catch (ClassNotFoundException evt) {
					System.out.println("Errore di classe");
				}
				if (type.equals("new")){
					try {
						user=(String) in.readObject();
					}	catch (ClassNotFoundException evt) {
						System.out.println("Errore di classe");
					}
					// dialog di richiesta
					ConfirmDialog okDialog = new ConfirmDialog(app,"Richiesta di gioco",true,user);
					okDialog.setVisible(true);
					if (app.risposta=="S") {
						out.writeObject("OK");
						app.setVisible(false);
						Tris gioco=new Tris(in,out,app.out,app.MyName,true,false,"0","0",app,user);
						Thread ThGioco=new Thread(gioco);
						ThGioco.start();
					} else {
						try {
							out.writeObject("NO");
							app.out.writeObject("deny");
							app.out.writeObject(app.MyName);
							app.out.writeObject(user);
						} catch (IOException evt) {
							System.out.println("Il server  caduto");
							app.ripristina(app);
						}
					}
				} else
					if (type.equals("load")) {
						try {
							user=(String) in.readObject();
						}	catch (ClassNotFoundException evt) {
							System.out.println("Errore di classe");
						}
						//dialog di richiesta
						ConfirmDialog okDialog = new ConfirmDialog(app,"Ripresa di gioco",true,user);
						okDialog.setVisible(true);
						if (app.risposta=="S") {
							out.writeObject("OK");
							app.setVisible(false);
							try {
								black=(String) in.readObject();
								white=(String) in.readObject();
								first=(String) in.readObject();
							}	catch (ClassNotFoundException evt) {
								System.out.println("Errore di classe");
							}
							Tris gioco;
							if (first.equals("false"))
								gioco=new Tris(in,out,app.out,app.MyName,true,false,white,black,app,user);
							else
								gioco=new Tris(in,out,app.out,app.MyName,false,false,white,black,app,user);
							Thread ThGioco=new Thread(gioco);
							ThGioco.start();
						} else {
							try {
								out.writeObject("NO");
								app.out.writeObject("deny");
								app.out.writeObject(app.MyName);
								app.out.writeObject(user);
							} catch (IOException evt) {
								System.out.println("Il server  caduto");
								app.ripristina(app);
							}
						}

					}			
			}
		} catch (IOException e) {
			System.out.println("errore accept");
		}
	}
}

class ConfirmDialog extends Dialog implements ActionListener {
	
	Frame parent;

	void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy) {
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = gw;
		gbc.gridheight = gh;
		gbc.weightx = wx;
		gbc.weighty = wy;
  	}
	
	ConfirmDialog (Frame parent, String title, boolean modal,String user){
		super(parent,title,modal);
		this.parent=parent;
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();	
		setLayout(gridbag);
		
		buildConstraints(constraints, 0, 0, 2, 1, 100, 100);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Label label = new Label(user+" vuole giocare con te, accetti?", Label.CENTER);
		gridbag.setConstraints(label, constraints);
		add(label);
		buildConstraints(constraints, 0, 1, 1, 1, 50, 50);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button okButton = new Button("S");
		gridbag.setConstraints(okButton, constraints);
		add(okButton);
		okButton.addActionListener(this);
		buildConstraints(constraints, 1, 1, 1, 1, 50, 50);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button cancelButton = new Button("No");
		gridbag.setConstraints(cancelButton, constraints);
		add(cancelButton);
		cancelButton.addActionListener(this);
		setSize(300,100);
		setLocation(225,225);
	}
	
	public void actionPerformed (ActionEvent evt) {
		((Client) parent).risposta=((Button)evt.getSource()).getLabel();
		setVisible(false);
	}
}