import java.net.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;


class listenServer implements Runnable {
	
	Client app;
	NewListenServer newServ;
	Thread th1;
	ServerSocket serSk;

	listenServer(Client app){
		this.app=app;
	}
	
	public void run() {
		while (true) {
			try {	
				//attesa di notifica dal server
				app.listenSk=app.serverSk.accept();
				newServ=new NewListenServer(app);
				// lancio del Thread NewServ di tipo NewListenServer
				th1=new Thread(newServ);
				th1.start();
			} catch (IOException e) {
				System.out.println("Errore di I/O");
			}
		}
	}
}

class NewListenServer implements Runnable {
	Client app;
	String Nome,action,res,act;
	Name name,name2;
	Name nameToRemove;
	Object array[];
	ListOfNames listaNomi=new ListOfNames();
	int i,i2;
		
	NewListenServer (Client app){
		this.app=app;
		this.listaNomi=app.listaNomi;
	}
	
	public void run(){
		try {
			/*creazione dello Stream di input per la ricezione delle notifiche
			 dal server */
			app.inLis = new ObjectInputStream(app.listenSk.getInputStream());
			/* ricezione del tipo di azione da applicare al nome ricevuto, 
			 cio aggiunta o rimozione */
			action=(String)(app.inLis.readObject());
			if (action.equals("r")) {
				// ricezione del nome da aggiungere/rimuovere
				name=(Name)(app.inLis.readObject());
				nameToRemove=new Name(name.nome);
				i=app.listaNomi.index(name.nome);
				array=app.listaNomi.toArray();
				// rimozione dalla lista locale dei nomi
				app.listaNomi.removeFromList((Name)array[i]);	
			}
			if (action.equals("a")){
				// ricezione del nome da aggiungere/rimuovere
				name=(Name)(app.inLis.readObject());
				// aggiunta del nome nella lista
				listaNomi.addToList(name);
			}
			if (action.equals("2r")){
				// ricezione del nome da aggiungere/rimuovere * 2 volte
				name=(Name)(app.inLis.readObject());
				name2=(Name)(app.inLis.readObject());
				i=app.listaNomi.index(name.nome);
				i2=app.listaNomi.index(name2.nome);
				array=app.listaNomi.toArray();
				// rimozione dalla lista locale dei nomi
				app.listaNomi.removeFromList((Name)array[i]);
				app.listaNomi.removeFromList((Name)array[i2]);
			}
			if (action.equals("2a")){
				// ricezione del nome da aggiungere/rimuovere * 2 volte
				name=(Name)(app.inLis.readObject());
				name2=(Name)(app.inLis.readObject());
				// aggiunta del nome nella lista
				listaNomi.addToList(name2);
				listaNomi.addToList(name);
			}
			// distruzione dello Stream d'input e della Socket
			app.inLis.close();
			app.listenSk.close();
		} catch (IOException e) {
			System.out.println("Il server  caduto");
			app.ripristina(app);
		}
		catch (ClassNotFoundException i) {
			System.out.println("Errore di classe");
		}
		// refresh della lista
		array=app.listaNomi.toArray();
		app.Lista.removeAll();
		// riscrittura della lista
		for (i=0;i<app.listaNomi.size();i++) {
			if (!((Name)array[i]).nome.equals(app.MyName))
				app.Lista.add(((Name)array[i]).nome);
		}
		app.repaint();
	}
}