import java.awt.*;
import java.awt.event.*;

class FrameControl extends Frame implements WindowListener {

	List lst,text,err;

	void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy) {
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = gw;
		gbc.gridheight = gh;
		gbc.weightx = wx;
		gbc.weighty = wy;
 	}

	FrameControl (String name){
		super(name);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();	
		setLayout(gridbag);
		setBackground(Color.lightGray);
		setSize(500,300);
		setLocation(100,100);
		
		// Label msg
		buildConstraints(constraints, 0, 0, 1, 1, 60, 5);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Label msg = new Label("Messaggi", Label.CENTER);
		gridbag.setConstraints(msg, constraints);
		msg.setFont(new Font("Sansserif",Font.BOLD,14));
		add(msg);
		
		// List text
		buildConstraints(constraints, 0, 1, 1, 1, 60, 45);
		constraints.fill = GridBagConstraints.BOTH;
		text=new List(10);
		text.setBackground(Color.lightGray);
		gridbag.setConstraints(text, constraints);
		add(text);
		
		// Label list
		buildConstraints(constraints, 0, 2, 1, 1, 60, 5);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Label list = new Label("Lista utenti collegati", Label.CENTER);
		gridbag.setConstraints(list, constraints);
		list.setFont(new Font("Sansserif",Font.BOLD,14));
		add(list);
		
		// List lst
		buildConstraints(constraints, 0, 3, 1, 1, 60, 45);
		constraints.fill = GridBagConstraints.BOTH;
		lst=new List(10);
		lst.setBackground(Color.lightGray);
		gridbag.setConstraints(lst, constraints);
		add(lst);
		
		// Label errori
		buildConstraints(constraints, 1, 0, 1, 1, 60, 5);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Label errori = new Label("Errori", Label.CENTER);
		gridbag.setConstraints(errori, constraints);
		errori.setFont(new Font("Sansserif",Font.BOLD,14));
		add(errori);
		
		// List err
		buildConstraints(constraints, 1, 1, 1, 3, 40, 45);
		constraints.fill = GridBagConstraints.BOTH;
		err=new List();
		err.setBackground(Color.lightGray);
		gridbag.setConstraints(err, constraints);
		add(err);
		addWindowListener(this);
	}

	public void windowClosing(WindowEvent e) {
		setVisible(false);
		dispose();
		System.exit(0);
	}

	public void windowOpened(WindowEvent evt ){}
	public void windowIconified(WindowEvent evt ){}
	public void windowDeiconified(WindowEvent evt ){}
	public void windowClosed(WindowEvent evt ){}
	public void windowActivated(WindowEvent evt ){}
	public void windowDeactivated(WindowEvent evt ){}

}