import java.net.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;
import NamePwd;
import ListOf;
import java.util.Collections;
import java.util.ArrayList;
import callOpponent;

public class Client extends Frame implements WindowListener {
	
	ListOfNames listaNomi=new ListOfNames(); //contiene l'elenco dei giocatori
	List Lista=new List(); //oggetto che visualizza la lista dei giocatori
	Scrollbar Barra;
	Socket connection,listenSk,gamesock;
	ServerSocket serverSk,gameSk;
	ObjectInputStream in,inLis,ingame;
	ObjectOutputStream out,outLis,outgame;
	String host=null;
	String MyName,risposta;
	Thread Th,ThAvv,ThServ;
	listenServer listen;
	listenOpponent avv;
	
	public Client(String name){
		super(name);
		// Ascolto me stesso
		addWindowListener(this);
	}
	
	public void windowClosing(WindowEvent e) {
		// Operazioni per la chiusura della finestra
		try {
			out.writeObject("close");
			out.writeObject(MyName);
			out.close();
			in.close();
			connection.close();
		} catch (IOException i) {
			System.out.println("Errore in chiusura");
		}
		catch (NullPointerException nul){
			System.out.println("Riferimento nullo");
		}
		setVisible(false);
		dispose();
		System.exit(0);
	}

	// Metodi dell'interfaccia WindowListener che non ho la necessit 
	// di ridefinire
	
	public void windowOpened(WindowEvent evt ){}
	public void windowIconified(WindowEvent evt ){}
	public void windowDeiconified(WindowEvent evt ){}
	public void windowClosed(WindowEvent evt ){}
	public void windowActivated(WindowEvent evt ){}
	public void windowDeactivated(WindowEvent evt ){}

	public void ripristina(Client client) {
	
		Client app=client;
		ServerDialog confDialog = new ServerDialog(app,"Server disconnesso",true);
		confDialog.setVisible(true);
		if (app.risposta.equals("S"))
			System.exit(0);
		else
			app.remove(app.Lista);
			app.Benvenuto();
	}
	
	public void CaricaGioco (Client client) {
		// apri un dialog per selezionare i possibili giochi salvati (estensione .sav)
		Client app=client;
		FileDialog carica = new FileDialog(app,"Load game...",FileDialog.LOAD);
		carica.show();
		String file = carica.getFile();
		System.out.println("File scelto "+file);
		carica.setVisible(false);
		carica.dispose();
		callOpponent newGame = new callOpponent(app,"",file);
		Thread ThNewGame = new Thread(newGame);
		ThNewGame.start();
	}

	public void Collegamento(String name, String pwd, String type){
		
		String user,pass,answ,tipo;
		String car=new String();
		NamePwd utente;
			
		Object array[];
		int i,port;
		
		user=name;
		pass=pwd;
		tipo=type;
		utente = new NamePwd(user,pass);
		
		MenuBar menu=this.getMenuBar();
		(menu.getMenu(0)).setEnabled(false);
		try {
			connection=new Socket(host,4321);	
			out = new ObjectOutputStream(connection.getOutputStream());
			in = new ObjectInputStream(connection.getInputStream());
		
			/* attivazione della serversocket diretta tra due client 
			su una porta libera */
			
			serverSk = new ServerSocket(0);
			gameSk = new ServerSocket(0);
			
			out.writeObject(utente);
			port=serverSk.getLocalPort();
			out.writeObject(new Integer(port));
			port=gameSk.getLocalPort();
			out.writeObject(new Integer(port));
			out.writeObject(tipo);
			
			try {
				car=(String) in.readObject();
			} catch (ClassNotFoundException e) {
				System.out.println("Errore di classe");
			}
			if (car.equals("yr") || car.equals("ya")) {
				MyName=name;
				try {
					listaNomi=(ListOfNames) in.readObject();
				} catch (ClassNotFoundException e) {
					System.out.println("Errore di classe");
				}
				//utilizzo il metodo sort della classe java.util.Collections

				// Copio il contenuto di listaNomi in Lista
				array=listaNomi.toArray();
				Lista.removeAll();
				for (i=0;i<listaNomi.size();i++) {
					if (!((Name)array[i]).nome.equals(name))	// evito di mostrare il MIO nome
						Lista.add(((Name)array[i]).nome);
				}
				Lista.setSize(100,100);						
				Lista.setLocation(50,50);
				setTitle(name);
				
				if (car.equals("yr")){
					Frame recOk = new Frame(utente.nome);
					recOk.setSize(200,100);
					recOk.setLocation(300,250);
					recOk.setBackground(Color.green);
					recOk.setFont(new Font("Arial",Font.BOLD,14));
					Label recLab=new Label("Registrazione avvenuta!",Label.CENTER);
					recOk.add(recLab);
					recOk.setVisible(true);
					try{
						Thread.sleep(2000);
					} catch (InterruptedException evt) {}
					recOk.setVisible(false);
					recOk.dispose();
					requestFocus();
				}
				else {
					Frame accOk = new Frame(utente.nome);
					accOk.setSize(200,100);
					accOk.setLocation(300,250);
					accOk.setBackground(Color.pink);
					accOk.setFont(new Font("Arial",Font.BOLD,14));
					Label recLab=new Label("Accesso avvenuto",Label.CENTER);
					accOk.add(recLab);
					accOk.setVisible(true);
					try{
						Thread.sleep(2000);
					} catch (InterruptedException evt) {}
					accOk.setVisible(false);
					accOk.dispose();
					requestFocus();
				}
				ListListener listListener = new ListListener(this);	
				Lista.addActionListener(listListener);
				repaint(0);	
				
				// attivazione Thread ascolto dell'oppositore
				avv= new listenOpponent(this);
				ThAvv=new Thread(avv);
				ThAvv.start();
			
				// attivazione del Thread di ascolto del server listenServer
				listen=new listenServer(this);
				Th=new Thread(listen);
				Th.start();
				
				NuovaSessione();
			}
			else {
				Frame errore = new Frame("Errore!");
				errore.setSize(100,100);
				errore.setLocation(350,250);
				errore.setBackground(Color.red);
				errore.setFont(new Font("Arial",Font.BOLD,14));
				Label errLab=new Label("Errore!",Label.CENTER);
				errore.add(errLab);
				errore.setVisible(true);
				try{
					Thread.sleep(2000);
				} catch (InterruptedException evt) {}
				errore.setVisible(false);
				errore.dispose();
				requestFocus();
			}	
		} catch (IOException e) {
			System.out.println("Errore di I/O");
		}
		(menu.getMenu(0)).setEnabled(true);
	}
		
	public void Benvenuto() {
		
		setTitle("Benvenuto!");
		menu1Listener ascoltaMenu1 = new menu1Listener(this);	
		MenuBar mioMenu1 = new MenuBar();
		Menu fileMenu1 = new Menu("File");
		MenuItem newSess = new MenuItem("New session",new MenuShortcut('n'));
		newSess.addActionListener(ascoltaMenu1);
		fileMenu1.add(newSess);
		MenuItem exit = new MenuItem("Exit",new MenuShortcut('x'));
		exit.addActionListener(ascoltaMenu1);
		fileMenu1.add(exit);
		mioMenu1.add(fileMenu1);
		setMenuBar(mioMenu1);
	}

	public void NuovaSessione() {
		
		setTitle(MyName+" Nuova Sessione");
		menu2Listener ascoltaMenu2 = new menu2Listener(this);	
		MenuBar mioMenu2 = new MenuBar();
		Menu fileMenu2 = new Menu("File");
		MenuItem newGame = new MenuItem("New game",new MenuShortcut('g'));
		newGame.addActionListener(ascoltaMenu2);
		fileMenu2.add(newGame);
		MenuItem loadGame = new MenuItem("Load game",new MenuShortcut('l'));
		loadGame.addActionListener(ascoltaMenu2);
		fileMenu2.add(loadGame);
		MenuItem back = new MenuItem("Back",new MenuShortcut('b'));
		back.addActionListener(ascoltaMenu2);
		fileMenu2.add(back);
		MenuItem exit = new MenuItem("Exit",new MenuShortcut('x'));
		exit.addActionListener(ascoltaMenu2);
		fileMenu2.add(exit);
		mioMenu2.add(fileMenu2);
		setMenuBar(mioMenu2);
	}
	
	public static void main(String[] args){
	
		Client client=new Client("Client");
		if (args.length<1) {
			System.out.println("usage: java Client <Ip address>");
			System.exit(0);
		}
		client.host=args[0];
		client.setBackground(SystemColor.window);
		client.setLocation(150,100);
		client.setSize(500,200);
		client.Benvenuto();
		client.show();
	}
}

/* Per quel che riguarda la richiesta di una nuova partita, il 
giocatore interpellato risponde si o no e si pone come server per la 
connessione peer to peer tra i due client. In parole pratiche, chi fa la
domanda si pone come client, chi riceve la domanda si pone come server */

class ServerDialog extends Dialog implements ActionListener {
	
	Frame parent;

	void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy) {
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = gw;
		gbc.gridheight = gh;
		gbc.weightx = wx;
		gbc.weighty = wy;
  	}
	
	ServerDialog (Frame parent, String title, boolean modal){
		super(parent,title,modal);
		this.parent=parent;
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();	
		setLayout(gridbag);
		
		buildConstraints(constraints, 0, 0, 2, 1, 100, 100);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Label label = new Label("Il server  caduto, vuoi terminare?", Label.CENTER);
		gridbag.setConstraints(label, constraints);
		add(label);
		buildConstraints(constraints, 0, 1, 1, 1, 50, 50);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button okButton = new Button("S");
		gridbag.setConstraints(okButton, constraints);
		add(okButton);
		okButton.addActionListener(this);
		buildConstraints(constraints, 1, 1, 1, 1, 50, 50);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button cancelButton = new Button("No");
		gridbag.setConstraints(cancelButton, constraints);
		add(cancelButton);
		cancelButton.addActionListener(this);
		setSize(300,100);
		setLocation(225,225);
	}
	
	public void actionPerformed (ActionEvent evt) {
		((Client) parent).risposta=((Button)evt.getSource()).getLabel();
		setVisible(false);
	}
}