import java.net.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;

class callOpponent implements Runnable {
	
	DataInputStream inFile;
	String player,answ,Ip;
	String file=new String();
	Client app;
	Integer port;
	Socket opp;
	ObjectInputStream oppIn;
	ObjectOutputStream oppOut;
	
	callOpponent(Client app, String player, String file) {
		this.player=player;
		this.app=app;
		this.file=file;
	}
	
	public void run(){
		try {	
			if (!player.equals("")) {
				// comunico al server che il client ha intenzione di giocare
				app.out.writeObject("play");
				//comunicazione del proprio nome
				app.out.writeObject(app.MyName);
				// comunicazione al server del giocatore che s'intende interpellare
				app.out.writeObject(player);
				// lettura dell'indirizzo Ip del gicatore (server) al quale collegarsi
				Ip =(String)(app.in.readObject());
				// lettura della porta di gioco del server
				port= new Integer((String)(app.in.readObject()));
				//creazione della socket 
				opp = new Socket(Ip,port.intValue());
				
				oppIn = new ObjectInputStream(opp.getInputStream());
				oppOut = new ObjectOutputStream(opp.getOutputStream());
		
				// invio al client la richiesta di un nuovo gioco
				oppOut.writeObject("new");
				// invio al client il mio nome
				oppOut.writeObject(app.MyName);
				answ = (String) oppIn.readObject();
				if (answ.equals("OK")) {
					app.setVisible(false);
					Tris newGame = new Tris (oppIn,oppOut,app.out,app.MyName,false,true,"0","0",app,player);
					Thread ThNewGame = new Thread(newGame);
					ThNewGame.start();
				}
				else {
					Frame errore = new Frame("Errore!");
					errore.setSize(300,100);
					errore.setLocation(350,250);
					errore.setBackground(Color.red);
					errore.setFont(new Font("Arial",Font.BOLD,14));
					Label errLab=new Label(player+" non ha accettato!",Label.CENTER);
					errore.add(errLab);
					errore.setVisible(true);
					try{
						Thread.sleep(2000);
					} catch (InterruptedException evt) {}
					errore.setVisible(false);
					errore.dispose();
				}
				
			} else {
				// comunico al server che il client ha intenzione di giocare
				app.out.writeObject("play");
				//comunicazione del proprio nome
				app.out.writeObject(app.MyName);
				try {
					inFile=new DataInputStream(new FileInputStream(file));
				} catch (FileNotFoundException e) {
					System.out.println("File non trovato");
				}
				String riga;
				try {
					riga=inFile.readUTF();
					// leggi la prima riga e verifica che ci sia scritto "Tris Over The Net"
					if (riga.equals("Tris Over The Net Savefile")) {
						// in caso positivo leggi opponent
						String me =inFile.readUTF();
						if (me.equals(app.MyName)) {
							String opponent= inFile.readUTF();
							// se l'opponent  collegato
							if (app.listaNomi.contains(new Name(opponent))) {
								// leggi gli altri parametri e chiedi all'opponent di giocare
								app.out.writeObject(opponent);
								String white=inFile.readUTF();
								String black=inFile.readUTF();
								String first=inFile.readUTF();
	
								Ip =(String)(app.in.readObject());
								// lettura della porta di gioco del server
								port= new Integer((String)(app.in.readObject()));
								//creazione della socket 
								opp = new Socket(Ip,port.intValue());
													
								oppIn = new ObjectInputStream(opp.getInputStream());
								oppOut = new ObjectOutputStream(opp.getOutputStream());
								
								oppOut.writeObject("load");
								oppOut.writeObject(me);
								answ=(String)(oppIn.readObject());
								oppOut.writeObject(white);
								oppOut.writeObject(black);
								oppOut.writeObject(first);
								
								//controlla se la risposta  OK
								
								if (answ.equals("OK")) {
									app.setVisible(false);
									// lancia poi il tris con i parametri corretti
									Tris newGame;
									if (first.equals("true"))
										newGame = new Tris (oppIn,oppOut,app.out,app.MyName,true,true,white,black,app,opponent);
									else
										newGame = new Tris (oppIn,oppOut,app.out,app.MyName,false,true,white,black,app,opponent);
									Thread ThNewGame = new Thread(newGame);
									ThNewGame.start();
								}
								else {
									Frame errore = new Frame("Errore!");
									errore.setSize(300,100);
									errore.setLocation(350,250);
									errore.setBackground(Color.red);
									errore.setFont(new Font("Arial",Font.BOLD,14));
									Label errLab=new Label(player+" non ha accettato!",Label.CENTER);
									errore.add(errLab);
									errore.setVisible(true);
									try{
										Thread.sleep(2000);
									} catch (InterruptedException evt) {}
									errore.setVisible(false);
									errore.dispose();
								}
							} else 	app.out.writeObject("");
						} else {
							app.out.writeObject("");
							System.out.println("Non  un mio savefile!!");
						}
					} else 
						System.out.println("Non  un savefile!!");
				} catch (IOException e) {
					System.out.println("Errore di I/O");
				}
			} 
		} catch (ClassNotFoundException n){
			System.out.println("Errore di classe");
		}
		catch (IOException e) {
			System.out.println("Il server  caduto");
			app.ripristina(app);
		}
	}
}